// MemoView_explorer.cpp  : Microsoft Visual C++  ActiveX Ʈ  Ŭ Դϴ.


#include "stdafx.h"
#include "MemoView_explorer.h"
#include <sstream>
#include "XHyperLink.h"
#include "NeMessengerDlg.h"

/////////////////////////////////////////////////////////////////////////////
// CMemoView_explorer

IMPLEMENT_DYNCREATE(CMemoView_explorer, CWnd)

// CMemoView_explorer ӼԴϴ.

// CMemoView_explorer ۾Դϴ.
BEGIN_EVENTSINK_MAP(CMemoView_explorerEx, CMemoView_explorer)
	ON_EVENT(CMemoView_explorerEx, IDC_MEMOVIEW_EXPLORER, 250, CMemoView_explorerEx::BeforeNavigate2MemoviewExplorer, VTS_DISPATCH VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PBOOL)
END_EVENTSINK_MAP()

void CMemoView_explorerEx::BeforeNavigate2MemoviewExplorer(LPDISPATCH pDisp, VARIANT* URL, VARIANT* Flags, VARIANT* TargetFrameName, VARIANT* PostData, VARIANT* Headers, BOOL* Cancel)
{
	USES_CONVERSION;

	CString szUrl(V_BSTR(URL));
	if (m_url != szUrl)
	{
		if(szUrl.GetLength() > 0)
		{
			if (szUrl == _T("http://127.0.0.1:8808/NtalkServer.html") || szUrl == _T("http://api-nnote.ncloudbiz.com/blank.html") )
			{

				POINT pt = {0};
				GetCursorPos(&pt);
				::MapWindowPoints(HWND_DESKTOP,m_hWnd,&pt,1);
				CComQIPtr<IHTMLDocument2> doc = get_Document();

				CComPtr<IHTMLElement> e;
				doc->elementFromPoint(pt.x,pt.y,&e);

				CComQIPtr<IHTMLAnchorElement> anchor = e;
				if (e && anchor)
				{
					VARIANT *var = (VARIANT*)PostData->byref;
					if (var->vt == (VT_ARRAY|VT_UI1))
					{
						SAFEARRAY *psarray = (SAFEARRAY*)var->parray;

						LONG size = 0;
						SafeArrayGetUBound(psarray,1,&size);
						
						CString strMsg = A2T((char*)psarray->pvData);

						std::vector<CString> v;
						int nCount = SplitString(strMsg, _T('&'), v);
						if (nCount == 2)
						{
							std::vector<CString> vt;
							nCount = SplitString(v[0], _T('='), vt);
							if (nCount == 2 
								&& vt[0].CompareNoCase(_T("type")) == 0 
								&& vt[1].CompareNoCase(_T("profile")) == 0)
							{
								vt.clear();
								nCount = SplitString(v[1], _T('='), vt);	
								if (nCount == 2 && vt[0].CompareNoCase(_T("userid")) == 0)
								{
									CComBSTR bstr;
									e->get_className(&bstr);

									CString userid = bstr;
									if (userid.Find(vt[1]) != 0)
									{
										
										RECT rc = {0};
										GetWindowRect(&rc);

										LONG x,y,w,h;
										e->get_offsetLeft(&x);
										e->get_offsetTop(&y);
										e->get_offsetWidth(&w);
										e->get_offsetHeight(&h);
						
										rc.left += x;
										rc.top += y;
										rc.right = rc.left + w;
										rc.bottom = rc.top + h;
										


										GET_MESSENGER_DLG()->GetProfileDlgController()->CreateProfileDlg(vt[1], rc, GetSafeHwnd());
										*Cancel = true;
										return;								}
								}

							}
						}
					}

				}
				//first-child
				return;
			}

			if (TRUE == CXHyperLink::UseAlreadyOpenedIE(szUrl))
			{
				return;
			}

			CXHyperLink::GotoURL(szUrl, SW_SHOWNORMAL);
		}
		*Cancel = TRUE;
	}
}

void CMemoView_explorerEx::NewViewer( UINT64 noteID )
{
	const char* hostAndPath = "http://api-nnote.ncloudbiz.com/viewCS.nhn";
	const char questionMark = '?';
	const char* ticket = "ticket";
	const char* noteSedRcvSeq = "noteSedRcvSeq";
	const char* lang = "lang";
	const char equal = '=';
	const char ampersand = '&';
	std::string kor = GetLanguageString();

	std::stringstream url;
	url << hostAndPath << questionMark;
	url << ticket << equal << g_pMessengerActor->GetMessengerTicket();
	url << ampersand << noteSedRcvSeq << equal << noteID;
	url << ampersand << lang << equal << kor;

	CComVariant URL(url.str().c_str());
	m_url = URL.bstrVal;
	CMemoView_explorer::Navigate2(&URL, 0, 0, 0, 0);
}
